<template>
  <q-list dense id="app_menu">
    <q-item-label class="q-pa-md"></q-item-label>
    <!--    <q-item-label class="text-grey-8 text-weight-bolder q-pt-md q-pb-sm q-pr-sm q-pl-sm" style="font-size: 18px">{{ header }}</q-item-label>-->
    <template v-for="(item, index) in menuItems">
      <menu-item v-if="item.visible" :key="index" v-bind="item"/>
    </template>
  </q-list>
</template>

<script>
import MenuItem from "components/Menu/MenuItem";
import {mapFields} from 'vuex-map-fields'
import {mapState} from 'vuex'
import get from "lodash/get";

export default {
  name: "AppMenu",
  components: {MenuItem},

  methods: {
    getDisplayableMenus(menus) {
      if (menus instanceof Array) {
        return menus.map(x => {
          if (x.subItems && x.subItems.length) {
            let menu = {...x}
            const childrenMenus = this.getDisplayableMenus(x.subItems)
            menu.subItems = childrenMenus
            menu.visible = false
            if (childrenMenus && childrenMenus.length) {
              childrenMenus.forEach(y => {
                if (y.visible)
                  menu.visible = true
              })
            }
            return menu
          } else if (x.permissions && x.permissions.length) {
            return {
              ...x,
              visible: this.userPermissions.some(up => x.permissions.includes(up))
            }
          } else {
            return {...x, visible: true}
          }
        })
      } else {
        return []
      }
    },
  },

  computed: {
    menuItems() {
      return this.getDisplayableMenus(this.allMenuItems)
    },
    ...mapFields('application', {
      allMenuItems: 'menus',
      header: 'header'
    }),
    ...mapState({
      userPermissions: state => get(state, 'auth.permissions', []) || [],
    })
  },
}
</script>

<style lang="scss">
#app_menu {
  .q-item__section--avatar {
    min-width: auto;
  }
}

</style>
